<!DOCTYPE html>
<head>
    <meta charset="utf-8"/>
    <title>twitter explorer</title>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/awesomplete/1.1.5/awesomplete.min.css" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/awesomplete/1.1.5/awesomplete.min.js"></script>
    <script async src="https://platform.twitter.com/widgets.js" charset="utf-8"></script>
    <script src="https://d3js.org/d3.v4.js"></script>
    <script src="https://unpkg.com/force-graph"></script>
    <link href="https://fonts.googleapis.com/css2?family=Inter:wght@400;700&display=swap" rel="stylesheet">     
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.4.1/jquery.min.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/file-saver@2.0.2/dist/FileSaver.min.js"></script>    
    <script src="https://code.jquery.com/ui/1.12.1/jquery-ui.js"></script>
    <script> 
    $(document).ready(function(){
      $("#panel00").click(function(){
        $("#content00").slideToggle(300);
              });
    });
    $(document).ready(function(){
      $("#panel01").click(function(){
        $("#content01").slideToggle(300);
      });
    });
    $(document).ready(function(){
      $("#panel02").click(function(){
        $("#content02").slideToggle(300);
      });
    });
    $(document).ready(function(){
      $("#panel03").click(function(){
        $("#content03").slideToggle(300);
      });
    });
    $(document).ready(function(){
      $("#panel04").click(function(){
        $("#content04").slideToggle(300);
      });
    });
    $(document).ready(function(){
      $("#panel04A").click(function(){
        $("#content04A").slideToggle(300);
      });
    });    
    $(document).ready(function(){
      $("#panel05").click(function(){
        $("#content05").slideToggle(300);
      });
    });
    $(document).ready(function(){
      $("#panel06").click(function(){
        $("#content06").slideToggle(300);
      });
    });
    $( function() {
        $( "#totalborder" ).draggable();
        } );
    </script>
<style>
.switch {
    position: relative;
    width: 60px;
    }
/* Hide default HTML checkbox */
    .onoffswitch {
        position: relative;         
        margin: 10px;
        /*margin-left:270px;*/
        width: 40px;
        -webkit-user-select:none; -moz-user-select:none; -ms-user-select: none;
    }
    .onoffswitch-checkbox {
        display: none;
    }
    .onoffswitch-label {
        display: block; overflow: hidden; cursor: pointer;
        height: 15px; padding: 0; line-height: 15px;
        border: 2px solid #999999; border-radius: 15px;
        background-color: #EEEEEE;
        transition: background-color 0.3s ease-in;
    }
    .onoffswitch-label:before {
        content: "";
        display: block; width: 15px; margin: 0px;
        background: #FFFFFF;
        position: absolute; top: 0; bottom: 0;
        right: 23px;
        border: 2px solid #999999; border-radius: 15px;
        transition: all 0.3s ease-in 0s; 
    }
    .onoffswitch-checkbox:checked + .onoffswitch-label {
        background-color: #fff;
    }
    .onoffswitch-checkbox:checked + .onoffswitch-label, .onoffswitch-checkbox:checked + .onoffswitch-label:before {
       border-color: #999999;
    }
    .onoffswitch-checkbox:checked + .onoffswitch-label:before {
        right: 0px; 
    }
    html.transition,
    html.transition *,
    html.transition *:before,
    html.transition *:after {
      transition: ease-in-out 200ms !important;
      transition-delay: 0 !important;
    }
      html {
          background: var(--backg);
                    --backg: #fff;
                    --color_text: #000;
                    --color_title_text: #fff;
                    --color_title_backg: #000;
                    --backg_buttons: rgba(0,0,0,0.15);}
      html[data-theme='darktheme'] {
          background: var(--backg);
          --backg: #000;
          --color_text: #fff;
          --color_title_text: #000;
          --color_title_backg: #fff;
          --backg_buttons: rgba(255,255,255,0.25)
            }
      body {margin: 0; 
            font-family: "Inter",-apple-system,system-ui,BlinkMacSystemFont,"Segoe UI",Roboto,"Helvetica Neue",Arial,sans-serif;
            font-size: 12pt;
            background-color: var(--backg);
            color: var(--color_text)}

        #totalborder {
        border: 1px;
        margin: 25px;
        width: 325px;
        border-style: solid;
        padding-left: 0px;
        position: relative;
        float: left;
        z-index: 10;
        background-color: var(--backg)
        }

        #totalborder:hover {
          cursor: move
        }
        
        #panel00{
          text-decoration: underline;
          text-transform: uppercase;
        }

        .borders {
          border: solid 1px;
          margin: 10px;
          width: 300px;
        }
        .borders_small {
          border: solid 1px;
          margin: 0px;
          width: 270px;
          margin-top: 10px
        }

        #title {
        padding: 10px;
        width: 300px;
        color: var(--color_title_text);
        font-size: 20pt;
        font-weight: bold;
        }

        #titleborder {
        background-color: var(--color_title_backg)
        }

        .content {
          display: none;
          padding: 10px;
        }

        .subtitle {
          padding: 10px;
        }
        .subsubtitle {
          padding: 5px;
          font-size: 11pt;
        }

        .subtitle:hover{
          background-color: var(--backg_buttons);
          cursor: pointer;
        }
        .subsubtitle:hover{
          background-color: var(--backg_buttons);
          cursor: pointer;
        }

        #footer{
          font-size: 8pt;
          padding-left: 10px;
          padding-bottom: 5px;
          color:grey;
        }

        a{
          color:var(--text-color);
        }
        #infodiv{
            padding-left: 20px;
            position: relative;
            float: left;
            z-index: 10;
        }
        iframe.infodiv{
                padding-left:0px;

        }
        @media(max-width:1000px){
            #infodiv{
                padding-left:0px;
            }
            #stripecontainer{
              padding-left:0;
            }
        }
        /* ---------------------------- */  
        /* ---------- Selector ---------- */
        #mainselection select {
           border: 1;
           border-width: 1px;
           /*border-color: black;*/
           border-radius: 4px;
           background: transparent;
           font-size: 11pt;
           color: var(--text_color);
           padding: 2px 5px;
           width: 270px;
           -webkit-appearance: none;
        }
        #mainselection {
           /*overflow:hidden;*/
           width:240px;
           border: 1;
           /*background: #58B14C no-repeat scroll 150px center;*/
        }
        /* ---------------------------- */  
        /* ---------- Button ---------- */
        .button1 {
            background-color:transparent;
            border-radius:4px;
            margin-top: 10px;
            border:1px solid;
            display:inline-block;
            cursor:pointer;
            color:var(--color_text);
            width: 119px;
            font-size:10pt;
            padding:5px 5px;
            /*padding:6px 36px;*/
            text-decoration:none;
            margin-right: 5px
          }
          .button1:hover {
            background-color: var(--backg_buttons);
          }
          .button1:active {
            position:relative;
            top:1px;
          }
        .button2 {
            background-color:transparent;
            border-radius:4px;
            margin-top: 20px;
            border:1px solid;
            display:inline-block;
            cursor:pointer;
            color:var(--color_text);
            width: 140px;
            font-size:10pt;
            padding:5px 5px;
            /*padding:6px 36px;*/
            text-decoration:none;
            margin-right: 5px
          }
          .button2:hover {
            background-color: var(--backg_buttons);
          }
          .button2:active {
            position:relative;
            top:1px;
          }                    
        /* ---------------------------- */  
        /* ---------- Checkbox ---------- */
        .checkbox {
            display: inline-flex;
            cursor: pointer;
            position: relative;
        }
        .checkbox > span {
            padding: 0.3rem 0.5rem;
            font-size: 12pt
        }
        .checkbox > input {
            height: 25px;
            width: 25px;
            -webkit-appearance: none;
            -moz-appearance: none;
            -o-appearance: none;
            appearance: none;
            border: 1px solid;
            border-radius: 4px;
            outline: none;
            transition-duration: 0.3s;
            background-color: transparent;
            cursor: pointer;
            margin-left: 1px
          }
        .checkbox > input:checked {
            border: 1px solid;
        }
        .checkbox > input:checked + span::before {
            content: '\2713';
            display: block;
            text-align: center;
            color: var(--color_text);
            position: absolute;
            left: 0.3rem;
            top: 0.2rem;
            font-size: 14pt

        }
        .checkbox > input:active {
            border: 2px solid #34495E;
        }
        .description{
            font-size:9pt;
            margin-top: 0px
        }
        .element{
          margin-bottom: 10px
        }
        #twittertimeline{
          margin-top: 0px
        }
        /* ---------------------------- */  
        /* ---------- Search Box ---------- */
        input[type=search] {
            border-radius: 4px;
            font-size: 12pt;
            width: 272px;
            background-color: transparent;
            color: var(--color_text);
        }
        /* ---------------------------- */
        ul{
            padding-left:15px;
            list-style-type:circle; 
            font-size: 11pt; 
            margin-top: 0px;
            margin-bottom: 0px;
        }
        #slido{width: 270px;}
        #time_slider{width: 270px;}
        #slido_links{width: 270px;}        
        #scale{margin-top: 20px}
        #user_retweets{
          overflow-y: scroll;
          scrollbar-width: none; /* Firefox */
          -ms-overflow-style: none;  /* Internet Explorer 10+ */          
          height: 300px;
        }
        #user_retweets::-webkit-scrollbar { /* WebKit */
        width: 0;
        height: 0;
        }
        #user_originaltweets{
          overflow-y: scroll;
          scrollbar-width: none; /* Firefox */
          -ms-overflow-style: none;  /* Internet Explorer 10+ */          
          height: 300px;
        }
        #user_originaltweets::-webkit-scrollbar { /* WebKit */
        width: 0;
        height: 0;
        }        
        .loader {
            border: 12px solid #f3f3f3;
            border-radius: 50%;
            border-top: 12px solid #444444;
            width: 35px;
            height: 35px;
            animation: spin 1s linear infinite;
            display: none;
        }        
        @keyframes spin {
            100% {
                transform: rotate(360deg);
            }
        }
        .svgbutton00 {
          padding-top: 6px;
          padding-bottom: 0px;
          }
          .svgbutton00:hover{
            cursor: pointer;
          }
        .svgbutton00 svg {
          width: 24px;
          height: 24px;
          stroke: var(--color_text);
          stroke-width: 4;
          stroke-linecap: square;
          stroke-linejoin: miter;
          fill: var(--color_text);
        }
        .svgbutton00 svg:hover{
            stroke: magenta;
        }             
        .svgbutton01 {
          /*border-radius: 4px;*/
          padding-top: 3px;          
          /*float: right;*/
          }
          .svgbutton01:hover{
            cursor: pointer;
          }
        .svgbutton01 svg {
          width: 30px;
          height: 30px;
          stroke: var(--color_text);
          stroke-width: 4;
          stroke-linecap: square;
          stroke-linejoin: miter;
          fill: none;
        }
        .svgbutton01 svg:hover{
            stroke: magenta;
        }          
</style>
</head>
<body>
<div id="totalborder">
<div style="display:flex">
<div style="padding-left: 10px;" class="svgbutton00">
<svg onclick='toggle_darkmode()' height='100px' width='100px'  fill="#000000" xmlns="http://www.w3.org/2000/svg" data-name="Layer 1" viewBox="0 0 100 100" x="0px" y="0px"><title>Toggle dark mode</title><path d="M50,2.5A47.5,47.5,0,1,0,97.5,50,47.5,47.5,0,0,0,50,2.5Zm0,90.56A43.06,43.06,0,1,1,93.06,50,43.11,43.11,0,0,1,50,93.06ZM14.93,49.56A35.51,35.51,0,0,0,50.44,85.07V14A35.51,35.51,0,0,0,14.93,49.56Z"></path></svg>
</div>
<div style="padding-left: 250px;" class="svgbutton01" title='Make a screenshot of the current graph view'>
<a id='camera'></a>    
<svg onclick='make_screenshot()' height='100px' width='100px'  fill="#000000" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" version="1.1" x="0px" y="0px" viewBox="0 0 100 100" enable-background="new 0 0 100 100" xml:space="preserve"><path d="M92.5,27.5H35V20c0-1.4-1.1-2.5-2.5-2.5h-15c-1.4,0-2.5,1.1-2.5,2.5v7.5H7.5C6.1,27.5,5,28.6,5,30v50c0,1.4,1.1,2.5,2.5,2.5  h85c1.4,0,2.5-1.1,2.5-2.5V30C95,28.6,93.9,27.5,92.5,27.5z M20,22.5h10v5H20V22.5z M90,77.5H10v-45h80V77.5z"></path><path d="M50,72.5c9.6,0,17.5-7.9,17.5-17.5S59.6,37.5,50,37.5S32.5,45.4,32.5,55S40.4,72.5,50,72.5z M50,42.5  c6.9,0,12.5,5.6,12.5,12.5S56.9,67.5,50,67.5S37.5,61.9,37.5,55S43.1,42.5,50,42.5z"></path></svg>
</div>
</div>
<div class="borders" id="titleborder" style="margin-top:0">
<div id="title">twitter explorer <span id="version_number" style="font-size:8pt"></span></div>
</div>
<div class="borders">
<div class= "subtitle" id="panel00"></div>
<div class = "content" id="content00">
</div>
</div>
<div class="borders">
<div class= "subtitle" id="panel01">VISUALIZATION OPTIONS</div>
<div class = "content" id="content01">
    <div id="mainselection" class="element">
        <div class="description">Auto-color nodes by</div>
            <select id = "nodecolor">
                <option value = "none" style="font-weight: bold"></option>
            </select>
        <br>
<!--         <div class="description">Node size (variable scale)</div>
            <select id = "nodesize">
                <option value = "none">None</option>
                <option value = "degree">Degree</option>
            </select>
 -->        </div>
        <div class="description" id="scale">Size scale</div>
        <div class="slidecontainer">
          <input type="range" min="1" max="10" value="3" id="slido">
        </div> 
        <div style="margin-top: 10px;" class="description" id="repulsion_scale">Node repulsion</div>
        <div class="slidecontainer">
        <input type="range" min="0" max="400" value="0" id="repulsion_slider" style="width:270px">
        </div>               
        <a href="javascript:void(0);" onclick="toggle_linkvisibility()" class="button2">Toggle link visibility</a>         
</div>
</div>
<div class="borders">
<div class= "subtitle" id="panel02">NETWORK MEASURES</div>
<div class = "content" id="content02">
</div>
</div>
<div class="borders">
<div class= "subtitle" id="panel03">HASHTAG INFORMATION</div>
<div class = "content" id="content03">
    <div class="description"> Search hashtag</div>
        <input id="searchuser" type="search"/>
        <br>
        <a href="javascript:void(0);" onclick="zoomonuser()" class="button1">Zoom on node</a>
        <a href="javascript:void(0);" onclick="openhashtag()" class="button1">Open timeline</a> 
<br><br>
    <div id="userinfostring"></div>        
</div>
</div>

<div id="footer"><a href="https://twitterexplorer.org">twitter explorer v0.3.1</a></div></div>

<div id="graph" style="width:100%;height: 100%;position: absolute;"></div>

    <script type="text/javascript">
        var data = {'nodes': [{'id': 0, 'name': '5août', 'degree': 6, 'louvain_com': 1}, {'id': 1, 'name': 'accrochage', 'degree': 6, 'louvain_com': 1}, {'id': 2, 'name': 'encours', 'degree': 6, 'louvain_com': 1}, {'id': 3, 'name': 'entreleslignes', 'degree': 6, 'louvain_com': 1}, {'id': 4, 'name': 'exhibition', 'degree': 6, 'louvain_com': 1}, {'id': 5, 'name': 'exposition', 'degree': 6, 'louvain_com': 1}, {'id': 6, 'name': 'marilyn', 'degree': 18, 'louvain_com': 1}, {'id': 7, 'name': 'marilynmonroe', 'degree': 24, 'louvain_com': 0}, {'id': 8, 'name': 'jump', 'degree': 4, 'louvain_com': 1}, {'id': 9, 'name': 'life', 'degree': 4, 'louvain_com': 1}, {'id': 10, 'name': 'philippehalsman', 'degree': 4, 'louvain_com': 1}, {'id': 11, 'name': 'pression', 'degree': 1, 'louvain_com': 1}, {'id': 12, 'name': 'marilynmonroe55th', 'degree': 1, 'louvain_com': 0}, {'id': 13, 'name': 'marilyneverywhere', 'degree': 14, 'louvain_com': 2}, {'id': 14, 'name': 'miltongreene', 'degree': 1, 'louvain_com': 0}, {'id': 15, 'name': 'délivrée', 'degree': 1, 'louvain_com': 9}, {'id': 16, 'name': 'libérée', 'degree': 1, 'louvain_com': 9}, {'id': 17, 'name': 'feuilleton', 'degree': 4, 'louvain_com': 6}, {'id': 18, 'name': 'lire', 'degree': 2, 'louvain_com': 6}, {'id': 19, 'name': 'enfin', 'degree': 3, 'louvain_com': 6}, {'id': 20, 'name': 'ilétaittemps', 'degree': 3, 'louvain_com': 6}, {'id': 21, 'name': 'semainier', 'degree': 3, 'louvain_com': 7}, {'id': 22, 'name': 'unemarilynparjour', 'degree': 1, 'louvain_com': 7}, {'id': 23, 'name': 'parlerenmarilyn', 'degree': 1, 'louvain_com': 10}, {'id': 24, 'name': 'volteface', 'degree': 1, 'louvain_com': 10}, {'id': 25, 'name': 'alertemarilyn', 'degree': 10, 'louvain_com': 3}, {'id': 26, 'name': 'honfleur', 'degree': 1, 'louvain_com': 3}, {'id': 27, 'name': 'yvesmontand100', 'degree': 1, 'louvain_com': 3}, {'id': 28, 'name': 'podcast', 'degree': 3, 'louvain_com': 4}, {'id': 29, 'name': 'radio', 'degree': 1, 'louvain_com': 4}, {'id': 30, 'name': 'vasescommunicants', 'degree': 2, 'louvain_com': 3}, {'id': 31, 'name': 'pro', 'degree': 1, 'louvain_com': 3}, {'id': 32, 'name': 'miroirmonbeaumiroir', 'degree': 1, 'louvain_com': 3}, {'id': 33, 'name': 'muséemarilyn', 'degree': 15, 'louvain_com': 0}, {'id': 34, 'name': 'relecture', 'degree': 2, 'louvain_com': 3}, {'id': 35, 'name': 'theplacetobe', 'degree': 1, 'louvain_com': 2}, {'id': 36, 'name': 'poligny', 'degree': 1, 'louvain_com': 0}, {'id': 37, 'name': 'magie', 'degree': 2, 'louvain_com': 0}, {'id': 38, 'name': 'objetsdemavie', 'degree': 1, 'louvain_com': 0}, {'id': 39, 'name': 'rentréelittéraire', 'degree': 1, 'louvain_com': 4}, {'id': 40, 'name': 'vendredilecture', 'degree': 3, 'louvain_com': 4}, {'id': 41, 'name': 'livres', 'degree': 5, 'louvain_com': 5}, {'id': 42, 'name': 'monroe', 'degree': 5, 'louvain_com': 5}, {'id': 43, 'name': 'musée', 'degree': 5, 'louvain_com': 5}, {'id': 44, 'name': 'presse', 'degree': 5, 'louvain_com': 5}, {'id': 45, 'name': 'roman', 'degree': 5, 'louvain_com': 5}, {'id': 46, 'name': 'enlisantenecrivant', 'degree': 2, 'louvain_com': 4}, {'id': 47, 'name': 'chartres', 'degree': 3, 'louvain_com': 0}, {'id': 48, 'name': 'littérature', 'degree': 3, 'louvain_com': 0}, {'id': 49, 'name': 'résidence', 'degree': 1, 'louvain_com': 7}, {'id': 50, 'name': 'saintgermainenlaye', 'degree': 1, 'louvain_com': 7}, {'id': 51, 'name': 'ready', 'degree': 1, 'louvain_com': 2}, {'id': 52, 'name': 'marilyneveryday', 'degree': 1, 'louvain_com': 2}, {'id': 53, 'name': 'allosimone', 'degree': 1, 'louvain_com': 2}, {'id': 54, 'name': 'lefiston', 'degree': 1, 'louvain_com': 2}, {'id': 55, 'name': 'studio28', 'degree': 1, 'louvain_com': 2}, {'id': 56, 'name': 'telematin', 'degree': 1, 'louvain_com': 2}, {'id': 57, 'name': 'poohpoohpeedo', 'degree': 1, 'louvain_com': 2}, {'id': 58, 'name': 'alertesmarilyn', 'degree': 3, 'louvain_com': 8}, {'id': 59, 'name': 'bib2paris', 'degree': 2, 'louvain_com': 8}, {'id': 60, 'name': 'cinéma', 'degree': 2, 'louvain_com': 8}, {'id': 61, 'name': 'cyanotype', 'degree': 1, 'louvain_com': 8}, {'id': 62, 'name': 'giphothèque', 'degree': 2, 'louvain_com': 3}, {'id': 63, 'name': 'iconotheque', 'degree': 2, 'louvain_com': 3}, {'id': 64, 'name': 'théâtre', 'degree': 2, 'louvain_com': 2}, {'id': 65, 'name': 'teamvarices', 'degree': 1, 'louvain_com': 2}, {'id': 66, 'name': 'annesavelli', 'degree': 5, 'louvain_com': 0}, {'id': 67, 'name': 'christinemarcandier', 'degree': 5, 'louvain_com': 0}, {'id': 68, 'name': 'diacritik', 'degree': 5, 'louvain_com': 0}, {'id': 69, 'name': 'éditionsinculte', 'degree': 5, 'louvain_com': 0}, {'id': 70, 'name': 'librairie', 'degree': 5, 'louvain_com': 0}, {'id': 71, 'name': 'litterature', 'degree': 5, 'louvain_com': 0}, {'id': 72, 'name': 'paris19', 'degree': 5, 'louvain_com': 0}, {'id': 73, 'name': 'rentreelitteraire', 'degree': 5, 'louvain_com': 0}], 'links': [{'source': 0, 'target': 1, 'weight': 1}, {'source': 0, 'target': 2, 'weight': 1}, {'source': 0, 'target': 3, 'weight': 1}, {'source': 0, 'target': 4, 'weight': 1}, {'source': 0, 'target': 5, 'weight': 1}, {'source': 0, 'target': 6, 'weight': 1}, {'source': 1, 'target': 2, 'weight': 1}, {'source': 1, 'target': 3, 'weight': 1}, {'source': 1, 'target': 4, 'weight': 1}, {'source': 1, 'target': 5, 'weight': 1}, {'source': 1, 'target': 6, 'weight': 1}, {'source': 2, 'target': 3, 'weight': 1}, {'source': 2, 'target': 4, 'weight': 1}, {'source': 2, 'target': 5, 'weight': 1}, {'source': 2, 'target': 6, 'weight': 1}, {'source': 3, 'target': 4, 'weight': 1}, {'source': 3, 'target': 5, 'weight': 1}, {'source': 3, 'target': 6, 'weight': 1}, {'source': 4, 'target': 5, 'weight': 1}, {'source': 4, 'target': 6, 'weight': 1}, {'source': 5, 'target': 6, 'weight': 1}, {'source': 6, 'target': 7, 'weight': 2}, {'source': 6, 'target': 8, 'weight': 1}, {'source': 6, 'target': 9, 'weight': 1}, {'source': 6, 'target': 10, 'weight': 1}, {'source': 6, 'target': 11, 'weight': 1}, {'source': 6, 'target': 13, 'weight': 1}, {'source': 6, 'target': 41, 'weight': 1}, {'source': 6, 'target': 42, 'weight': 1}, {'source': 6, 'target': 43, 'weight': 1}, {'source': 6, 'target': 44, 'weight': 1}, {'source': 6, 'target': 45, 'weight': 1}, {'source': 6, 'target': 64, 'weight': 1}, {'source': 7, 'target': 8, 'weight': 1}, {'source': 7, 'target': 9, 'weight': 1}, {'source': 7, 'target': 10, 'weight': 1}, {'source': 7, 'target': 12, 'weight': 1}, {'source': 7, 'target': 13, 'weight': 3}, {'source': 7, 'target': 14, 'weight': 1}, {'source': 7, 'target': 17, 'weight': 3}, {'source': 7, 'target': 18, 'weight': 2}, {'source': 7, 'target': 19, 'weight': 1}, {'source': 7, 'target': 20, 'weight': 1}, {'source': 7, 'target': 33, 'weight': 4}, {'source': 7, 'target': 36, 'weight': 1}, {'source': 7, 'target': 37, 'weight': 1}, {'source': 7, 'target': 47, 'weight': 1}, {'source': 7, 'target': 48, 'weight': 1}, {'source': 7, 'target': 66, 'weight': 1}, {'source': 7, 'target': 67, 'weight': 1}, {'source': 7, 'target': 68, 'weight': 1}, {'source': 7, 'target': 69, 'weight': 1}, {'source': 7, 'target': 70, 'weight': 1}, {'source': 7, 'target': 71, 'weight': 1}, {'source': 7, 'target': 72, 'weight': 1}, {'source': 7, 'target': 73, 'weight': 1}, {'source': 8, 'target': 9, 'weight': 1}, {'source': 8, 'target': 10, 'weight': 1}, {'source': 9, 'target': 10, 'weight': 1}, {'source': 13, 'target': 25, 'weight': 1}, {'source': 13, 'target': 30, 'weight': 1}, {'source': 13, 'target': 35, 'weight': 1}, {'source': 13, 'target': 51, 'weight': 1}, {'source': 13, 'target': 52, 'weight': 1}, {'source': 13, 'target': 53, 'weight': 1}, {'source': 13, 'target': 54, 'weight': 1}, {'source': 13, 'target': 55, 'weight': 1}, {'source': 13, 'target': 56, 'weight': 1}, {'source': 13, 'target': 57, 'weight': 1}, {'source': 13, 'target': 64, 'weight': 1}, {'source': 13, 'target': 65, 'weight': 1}, {'source': 15, 'target': 16, 'weight': 1}, {'source': 17, 'target': 18, 'weight': 2}, {'source': 17, 'target': 19, 'weight': 1}, {'source': 17, 'target': 20, 'weight': 1}, {'source': 19, 'target': 20, 'weight': 1}, {'source': 21, 'target': 22, 'weight': 1}, {'source': 21, 'target': 49, 'weight': 1}, {'source': 21, 'target': 50, 'weight': 1}, {'source': 23, 'target': 24, 'weight': 1}, {'source': 25, 'target': 26, 'weight': 1}, {'source': 25, 'target': 27, 'weight': 1}, {'source': 25, 'target': 30, 'weight': 1}, {'source': 25, 'target': 31, 'weight': 1}, {'source': 25, 'target': 32, 'weight': 1}, {'source': 25, 'target': 33, 'weight': 1}, {'source': 25, 'target': 34, 'weight': 1}, {'source': 25, 'target': 62, 'weight': 1}, {'source': 25, 'target': 63, 'weight': 1}, {'source': 28, 'target': 29, 'weight': 1}, {'source': 28, 'target': 40, 'weight': 1}, {'source': 28, 'target': 46, 'weight': 1}, {'source': 33, 'target': 34, 'weight': 1}, {'source': 33, 'target': 37, 'weight': 1}, {'source': 33, 'target': 38, 'weight': 1}, {'source': 33, 'target': 47, 'weight': 1}, {'source': 33, 'target': 48, 'weight': 1}, {'source': 33, 'target': 66, 'weight': 1}, {'source': 33, 'target': 67, 'weight': 1}, {'source': 33, 'target': 68, 'weight': 1}, {'source': 33, 'target': 69, 'weight': 1}, {'source': 33, 'target': 70, 'weight': 1}, {'source': 33, 'target': 71, 'weight': 1}, {'source': 33, 'target': 72, 'weight': 1}, {'source': 33, 'target': 73, 'weight': 1}, {'source': 39, 'target': 40, 'weight': 1}, {'source': 40, 'target': 46, 'weight': 1}, {'source': 41, 'target': 42, 'weight': 1}, {'source': 41, 'target': 43, 'weight': 1}, {'source': 41, 'target': 44, 'weight': 1}, {'source': 41, 'target': 45, 'weight': 1}, {'source': 42, 'target': 43, 'weight': 1}, {'source': 42, 'target': 44, 'weight': 1}, {'source': 42, 'target': 45, 'weight': 1}, {'source': 43, 'target': 44, 'weight': 1}, {'source': 43, 'target': 45, 'weight': 1}, {'source': 44, 'target': 45, 'weight': 1}, {'source': 47, 'target': 48, 'weight': 1}, {'source': 58, 'target': 59, 'weight': 1}, {'source': 58, 'target': 60, 'weight': 1}, {'source': 58, 'target': 61, 'weight': 1}, {'source': 59, 'target': 60, 'weight': 1}, {'source': 62, 'target': 63, 'weight': 1}, {'source': 66, 'target': 67, 'weight': 1}, {'source': 66, 'target': 68, 'weight': 1}, {'source': 66, 'target': 69, 'weight': 1}, {'source': 67, 'target': 68, 'weight': 1}, {'source': 67, 'target': 69, 'weight': 1}, {'source': 68, 'target': 69, 'weight': 1}, {'source': 70, 'target': 71, 'weight': 1}, {'source': 70, 'target': 72, 'weight': 1}, {'source': 70, 'target': 73, 'weight': 1}, {'source': 71, 'target': 72, 'weight': 1}, {'source': 71, 'target': 73, 'weight': 1}, {'source': 72, 'target': 73, 'weight': 1}], 'graph': {'type': 'Hashtag network', 'N_nodes': 74, 'N_links': 135, 'keyword': '', 'collected_on': 'all.twitwi', 'first_tweet': '2022-09-14 15:00', 'last_tweet': '2015-08-05 17:19'}, 'version_number': '0.6.7'}
    </script>
    
<script>
var colorselector = document.getElementById("nodecolor");
var nodescaling = 3;
var darkmode = false

// get node color options
ms = document.getElementById('nodecolor')
if ('louvain_com' in data.nodes[0]){ms.innerHTML+=`<option value = "louvain_com">Louvain community</option>\n`}
if ('leiden_com' in data.nodes[0]){ms.innerHTML+=`<option value = "leiden_com">Leiden community</option>\n`}

var nodecolor = colorselector.options[colorselector.selectedIndex].value;
const elem = document.getElementById('graph');
const Graph = ForceGraph()(elem)
.graphData({nodes: data.nodes, links: data.links})
.nodeColor(node => "black")
.nodeLabel("")
.nodeCanvasObject((node, ctx, globalScale) => {
  const label = node.name;
  const fontSize = Math.log(1+node.degree) * nodescaling
  ctx.font = `${fontSize}px Inter`;
  const textWidth = ctx.measureText(label).width;
  const bckgDimensions = [textWidth, fontSize].map(n => n + fontSize * 0.1); // some padding

  ctx.fillStyle = 'rgba(255, 255, 255, 0.8)';
  // ctx.fillRect(node.x - bckgDimensions[0] / 2, node.y - bckgDimensions[1] / 2, ...bckgDimensions);

  ctx.textAlign = 'center';
  ctx.textBaseline = 'middle';
  ctx.fillStyle = "black";
  ctx.fillText("#"+label, node.x, node.y);
}) 
.nodeId('id')
.linkHoverPrecision(10)
.linkColor(link => 'rgba(0,0,0,0.1)')
.onNodeClick(node => {highlight(node)})
.onNodeRightClick(node => { Graph.centerAt(node.x, node.y, 1000);Graph.zoom(8, 2000);})

// Get the list of all users for autocomplete
var users = []
for(var i in data.nodes)
  users.push(data.nodes[i].name);

var name = document.getElementById("searchuser").value;

        function highlight(node){
    $("#content03").slideDown(300);
    pastenodeinfo(node);
    var neighbors = []
    neighbors.push(node)

    for (link of data.links) {
      if (link.source == node) {
        neighbors.push(link.target)
        link.colorthat = 1
      }
      else if (link.target == node){
        neighbors.push(link.source)
        link.colorthat = 1
      }
      else {link.colorthat=0}
    }
    for (node of data.nodes){
      if(neighbors.includes(node)){
        node.colorthat = 1
      }
      else node.colorthat = 0}
    colorbar = ['#d3d3d3', 'red']
    var nodescaleslider = document.getElementById("slido");
    var newscale = nodescaleslider.value  
  
    Graph.nodeCanvasObject((node, ctx, globalScale) => {
          const label = node.name;
          const fontSize = Math.log(1+node.degree) * newscale
          ctx.font = `${fontSize}px Inter`;
          const textWidth = ctx.measureText(label).width;
          const bckgDimensions = [textWidth, fontSize].map(n => n + fontSize * 0.1); // some padding

          ctx.fillStyle = 'rgba(255, 255, 255, 1.0)';
          // ctx.fillRect(node.x - bckgDimensions[0] / 2, node.y - bckgDimensions[1] / 2, ...bckgDimensions);

          ctx.textAlign = 'center';
          ctx.textBaseline = 'middle';
          ctx.fillStyle = colorbar[node.colorthat];
          ctx.fillText("#"+label, node.x, node.y);
        })
    // linkcolor depending on dark/lightmode
    var bodyelement = document.querySelector('body')
    var bodystyle = window.getComputedStyle(bodyelement)
    var bg = bodystyle.getPropertyValue('color')
    if (bg === 'rgb(0, 0, 0)') {var colorbar2 = ['rgba(0,0,0,0.05)', 'rgba(255,0,0,0.5)']}
    if (bg === 'rgb(255, 255, 255)') {var colorbar2 = ['rgba(255,255,255,0.03)', 'rgba(255,0,0,0.5)']}
    Graph.linkColor(link => colorbar2[link.colorthat])
    }
    Graph.onBackgroundClick(() => resetcolors())

    function resetcolors(){
    var colorselector = document.getElementById("nodecolor");
    var selectedoption = colorselector.options[colorselector.selectedIndex].value

    var nodescaleslider = document.getElementById("slido");
    var newscale = nodescaleslider.value  
    
        Graph.nodeCanvasObject((node, ctx, globalScale) => {
          const label = node.name;
          const fontSize = Math.log(1+node.degree) * newscale
          ctx.font = `${fontSize}px Inter`;
          const textWidth = ctx.measureText(label).width;
          const bckgDimensions = [textWidth, fontSize].map(n => n + fontSize * 0.1); // some padding

          ctx.fillStyle = 'rgba(255, 255, 255, 1.0)';
          // ctx.fillRect(node.x - bckgDimensions[0] / 2, node.y - bckgDimensions[1] / 2, ...bckgDimensions);

          ctx.textAlign = 'center';
          ctx.textBaseline = 'middle';
        if (selectedoption == "louvain_com" ) {ctx.fillStyle = colorscale[node["louvain_com"]];}
        else if (selectedoption == "leiden_com" ) {ctx.fillStyle = colorscale[node["leiden_com"]];}                
        else { if (darkmode == true) {ctx.fillStyle = "white";} else {ctx.fillStyle = "black";}}
          ctx.fillText("#"+label, node.x, node.y);
        })
        if (darkmode == false){Graph.linkColor(link => 'rgba(0,0,0,0.1)')}
        else {Graph.linkColor(link => 'rgba(255,255,255,0.2)')}
        
        }
var input = document.getElementById("searchuser");
new Awesomplete(input, {
list: users
  });
var name = document.getElementById("searchuser").value;

// var searcheduser = document.getElementById("searchuser").value;

function zoomonuser(){
  var name = document.getElementById("searchuser").value;
  const getNode = id => {
      return data.nodes.find(node => node.name === name);
  }
  var nodeathand = getNode(name)
  Graph.centerAt(nodeathand.x, nodeathand.y, 1000);Graph.zoom(8, 2000);
  }

function resetzoom(){
  Graph.centerAt(0, 0,1000);Graph.zoom(0.8, 1000)
}

// LIGHT / DARK MODE
function toggle_darkmode() {
var colorselector = document.getElementById("nodecolor");
var bytype = colorselector.options[colorselector.selectedIndex].value
var nodescaleslider = document.getElementById("slido");
var newscale = nodescaleslider.value  

if (darkmode == false) {
darkmode = true
document.documentElement.setAttribute('data-theme', 'darktheme');
Graph.linkColor(() => 'rgba(255,255,255,0.2)');
Graph.nodeCanvasObject((node, ctx, globalScale) => {
      const label = node.name;
      const fontSize = Math.log(1+node.degree) * newscale
      ctx.font = `${fontSize}px Inter`;
      const textWidth = ctx.measureText(label).width;
      const bckgDimensions = [textWidth, fontSize].map(n => n + fontSize * 0.1); // some padding

      // ctx.fillRect(node.x - bckgDimensions[0] / 2, node.y - bckgDimensions[1] / 2, ...bckgDimensions);

      ctx.textAlign = 'center';
      ctx.textBaseline = 'middle';
      if (bytype == "louvain_com"){ctx.fillStyle = colorscale[node["louvain_com"]]}
      else if (bytype == "leiden_com"){ctx.fillStyle = colorscale[node["leiden_com"]]}        
      else {ctx.fillStyle = "white"}
      ;
      ctx.fillText("#"+label, node.x, node.y);
    })
}

else {
darkmode = false   
document.documentElement.setAttribute('data-theme', 'lighttheme');
Graph.linkColor(() => 'rgba(0,0,0,0.2)');
Graph.nodeCanvasObject((node, ctx, globalScale) => {
      const label = node.name;
      const fontSize = Math.log(1+node.degree) * newscale
      ctx.font = `${fontSize}px Inter`;
      const textWidth = ctx.measureText(label).width;
      const bckgDimensions = [textWidth, fontSize].map(n => n + fontSize * 0.1); // some padding

      // ctx.fillStyle = 'rgba(255, 255, 255, 1.0)';
      // ctx.fillRect(node.x - bckgDimensions[0] / 2, node.y - bckgDimensions[1] / 2, ...bckgDimensions);

      ctx.textAlign = 'center';
      ctx.textBaseline = 'middle';
      if (bytype == "louvain_com"){ctx.fillStyle = colorscale[node["louvain_com"]]}
      else if (bytype == "leiden_com"){ctx.fillStyle = colorscale[node["leiden_com"]]}        
      else {ctx.fillStyle = "black"}
      ;
      ctx.fillText("#"+label, node.x, node.y);
    })
}    
}

var colorscale = ['#e6194b', '#3cb44b', '#ffe119', '#4363d8', '#f58231', '#911eb4', '#46f0f0', '#f032e6', '#bcf60c', '#fabebe', '#008080', '#e6beff', '#9a6324', '#fffac8', '#800000', '#aaffc3', '#808000', '#ffd8b1', '#000075', '#808080', '#ffffff', '#000000']

function changecolor(bytype) {

var nodescaleslider = document.getElementById("slido");
var newscale = nodescaleslider.value  

Graph.nodeCanvasObject((node, ctx, globalScale) => {
      const label = node.name;
      const fontSize = Math.log(1+node.degree) * newscale
      ctx.font = `${fontSize}px Inter`;
      const textWidth = ctx.measureText(label).width;
      const bckgDimensions = [textWidth, fontSize].map(n => n + fontSize * 0.1); // some padding

      ctx.fillStyle = 'rgba(255, 255, 255, 1.0)';
      // ctx.fillRect(node.x - bckgDimensions[0] / 2, node.y - bckgDimensions[1] / 2, ...bckgDimensions);

      ctx.textAlign = 'center';
      ctx.textBaseline = 'middle';
      if (bytype == "louvain_com"){ctx.fillStyle = colorscale[node["louvain_com"]]}
      else if (bytype == "leiden_com"){ctx.fillStyle = colorscale[node["leiden_com"]]}        
      else {ctx.fillStyle = "black"}
      ;
      ctx.fillText("#"+label, node.x, node.y);
    })}

document.getElementById("nodecolor").addEventListener("change", recolornodes);
function recolornodes(){

  var colorselector = document.getElementById("nodecolor");
  var selectedoption = colorselector.options[colorselector.selectedIndex].value
  console.log(selectedoption)
  if (selectedoption != "none"){
  changecolor(selectedoption)}            
  else { 
  var bodyelement = document.querySelector('body')
  var bodystyle = window.getComputedStyle(bodyelement)
  var bg = bodystyle.getPropertyValue('color')
  if (bg === 'rgb(0, 0, 0)') {var nodecol = 'black'}
  if (bg === 'rgb(255, 255, 255)') {var nodecol = 'white'}
  changecolor("none")} }

function openhashtag(){ 
  var hashtagname = document.getElementById("searchuser").value;
  window.open(`https://twitter.com/search?q=%23${hashtagname}`, '_blank');
  }

// NODE SIZE
document.getElementById("slido").addEventListener("change", rescalenodes);
function rescalenodes(){
  var colorselector = document.getElementById("nodecolor");
  var selectedoption = colorselector.options[colorselector.selectedIndex].value
  var nodescaleslider = document.getElementById("slido");
  var newscale = nodescaleslider.value  
  Graph.nodeCanvasObject((node, ctx, globalScale) => {
    const label = node.name;
    const fontSize = Math.log(1+node.degree) * newscale
    ctx.font = `${fontSize}px Inter`;
    const textWidth = ctx.measureText(label).width;
    const bckgDimensions = [textWidth, fontSize].map(n => n + fontSize * 0.1); // some padding

    ctx.fillStyle = 'rgba(255, 255, 255, 1.0)';
    // ctx.fillRect(node.x - bckgDimensions[0] / 2, node.y - bckgDimensions[1] / 2, ...bckgDimensions);

    ctx.textAlign = 'center';
    ctx.textBaseline = 'middle';

    if (selectedoption == "louvain_com" ) {ctx.fillStyle = colorscale[node["louvain_com"]];}
    else if (selectedoption == "leiden_com" ) {ctx.fillStyle = colorscale[node["leiden_com"]];}    
    else {ctx.fillStyle = "black";}
    
    ctx.fillText("#"+label, node.x, node.y);
  })  

}
function make_screenshot(){
// var canvas = document.getElementsByClassName('force-graph-container')[0]['children'][0];
var canvas = document.getElementById('graph')['children'][0]['children'][0]
console.log(canvas)
var link = document.getElementById('camera');
link.setAttribute('download', 'screenshot.png');
link.setAttribute('href', canvas.toDataURL("image/png").replace("image/png", "image/octet-stream"));
link.click()
}
$(function() {
var sizeval="degree"; 
$("#nodesize").val(sizeval);
});

function toggle_linkvisibility(){
    if (Graph.linkVisibility() == true){
        Graph.linkVisibility(false)
    }
    else {Graph.linkVisibility(true)}
}

// NODE INFO ON HOVER
function pastenodeinfo(node){
userinfostring = `<ul> 
<li> Degree: ${node.degree}
</ul>`
document.getElementById('userinfostring').innerHTML = userinfostring
document.getElementById("searchuser").value = node.name}

var netinfo = `<ul> 
<li> Keyword: ${data.graph.keyword}</li>
<li> Collected on: ${data.graph.collected_on}</li>
<li> First tweet: ${data.graph.first_tweet}</li>
<li> Last tweet: ${data.graph.last_tweet}</li>
</ul>`
var netmeasures = `
<ul>
  <li>Nodes: ${data.graph.N_nodes}</li>
  <li>Links: ${data.graph.N_links}</li>
</ul>`
document.getElementById('panel00').innerHTML = data.graph.type
document.getElementById('content00').innerHTML = netinfo
document.getElementById('content02').innerHTML = netmeasures
document.getElementById('version_number').innerHTML = data.version_number

// NODE REPULSION
document.getElementById("repulsion_slider").addEventListener("change", rescale_repulsion);
function rescale_repulsion(){
  var repulsion_slider = document.getElementById("repulsion_slider");
  var newscale_repulsion = repulsion_slider.value 
  Graph.d3ReheatSimulation() 
  Graph.d3Force('charge').strength(-newscale_repulsion)
}

</script>
</body>